﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Verse;

namespace RimWorld
{
    class PsychicPowerDriver_Assimilation : PsychicPowerDriver
    {
        public override void UsePower(PsychicPowerDef power, Pawn user, Pawn target)
        {
            if(target.skills != null && user.skills != null)
            {
                foreach(SkillRecord skill in target.skills.skills)
                {
                    if(skill.Level > user.skills.GetSkill(skill.def).Level)
                    {
                        user.skills.GetSkill(skill.def).Level += 1;
                    }
                }
            }

            if (Rand.Chance(0.4f))
            {
                target.health.AddHediff(HediffDefOf.MissingBodyPart, target.RaceProps.body.GetPartsWithTag(BodyPartTagDefOf.ConsciousnessSource).First());
            }
            else
            {
                BodyPartRecord brain = target.health.hediffSet.GetBrain();
                if (brain == null)
                    return;
                int num = Rand.RangeInclusive(1, 5);
                DamageDef flame = DamageDefOf.Flame;
                float amount = (float)num;
                target.TakeDamage(new DamageInfo(flame, amount, 0f, -1f, user, brain, null, DamageInfo.SourceCategory.ThingOrUnknown, null));
            }
        }
    }
}
